package MyProjects.MyLib;

/*  This file defines the exact commands used to control our laser system.
*  @Version 1.0   22 Aug 2005
*  @Frederic Durville - OFSI
*/

public class CommandLibrary{

// The following String Array defines the actual commands

  final static String [] MyCommands = {
                            "EMGCY",
                            "LSROF",
                            "DTERDY",
                            "!PWR:",
                            "LSRDY",
                            "LSRON",
                            "?PWR:",
                            "STDBY",
                            "?LSR?"
                            };

   final static String [] Status = {
                            "$LSR:000",
                            "$LSR:CHK",
                            "$LSR:OK ",
                            "$LSR:SBY",
                            "$LSR:DLY",
                            "$LSR:RDY",
                            "$LSR:ON ",
                            "!ERROR  ",
                            "!PWR:EOR"
                            };


   public static char [] StatusChar(int status){
   char [] ReturnStatus;
   ReturnStatus=new char[Status[status].length()];
    for (int i=0;i<Status[status].length();i++){
    ReturnStatus[i]=Status[status].charAt(i);
    }
   return ReturnStatus;
   }

// This method is used to identify which command has been received.
// It checks a match betwee the received character array data
// and any of the String defined in the String array MyCommands.
// It returns an integer corresponding to the index+1 of the matched String.

  public static int MatchCommand(char [] data) {

  int m=0;
  int i=1;
  int icmd=0;

    while (m<1 && icmd<MyCommands.length){
      while (i>0 && i<MyCommands[icmd].length()+1){
        if (data[i-1] == MyCommands[icmd].charAt(i-1)) i++;
        else i=0;
        if (i==MyCommands[icmd].length()+1) m=icmd+1;
      }
      i=1;
      icmd++;
    }
  return m;
  }

}